123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354 |
- #!/usr/bin/env bash
- # This script is executed by GitHub Actions for every successful push (on any branch, PR or not).
- # It runs some basic tests on pages. If the build is also a PR, additional
- # checks are run through the check-pr script, and any message or error is sent
- # to tldr-bot to be commented on the PR.
- #
- # NOTE: must be run from the repository root directory to correctly work!
- # NOTE: `set -e` is applied conditionally only if needed.
- # Default test function, ran by `npm test`.
- function run_tests {
- markdownlint pages*/**/*.md
- tldr-lint ./pages
- }
- # Special test function for GitHub Actions pull request builds.
- # Runs run_tests collecting errors for tldr-bot.
- function run_tests_pr {
- errs=$(run_tests 2>&1)
- if [ -n "$errs" ]; then
- echo -e "Test failed!\n$errs\n" >&2
- echo 'Sending errors to tldr-bot.' >&2
- echo -n "$errs" | python3 scripts/send-to-bot.py report-errors
- exit 1
- fi
- }
- # Additional checks for GitHub Actions pull request builds.
- # Only taken as suggestions, does not make the build fail.
- function run_checks_pr {
- msgs=$(bash scripts/check-pr.sh)
- if [ -n "$msgs" ]; then
- echo -e "\nCheck PR reported the following message(s):\n$msgs\n" >&2
- echo 'Sending check results to tldr-bot.' >&2
- echo -n "$msgs" | python3 scripts/send-to-bot.py report-check-results
- fi
- }
- ###################################
- # MAIN
- ###################################
- if [ "$CI" = "true" ] && [ "$GITHUB_REPOSITORY" = "tldr-pages/tldr" ] && [ "$PULL_REQUEST_ID" != "" ]; then
- run_checks_pr
- run_tests_pr
- else
- set -e
- run_tests
- fi
- echo 'Test ran succesfully!'
|